# Common targets for kernel mode build makefiles
# ==============================================

#----------------------------------------------------------------------
# Clean-up, rebuild, etc.
# -----------------------

# set KRN_EXE_PATH to the path where build.exe builds executables
#
KRN_EXE_PATH = $(TARGETPATH)\i386

# set KRN_OBJ_PATH to the path where build.exe builds .obj files.
# It relies on the fact that build.exe creates object files
# into the path given by obj$(BUILD_ALT_DIR).
#
KRN_OBJ_PATH = obj$(BUILD_ALT_DIR)

# set KRN_SRC_PATH to the path of source files relative to the directory
# from which build.exe is run.
#
KRN_SRC_PATH = ..

# Target for clean-up.
#
clean:
	if exist $(TARGETPATH)       rd $(TARGETPATH)   /s /q 
    if exist $(ASMOBJDIR)        rd $(ASMOBJDIR)    /s /q
    if exist $(KRN_OBJ_PATH)     rd $(KRN_OBJ_PATH) /s /q

# Delete only files created by the linker
#
cleanlinkout:
	if exist $(KRN_EXE_PATH)\*.exe del $(KRN_EXE_PATH)\*.exe
	if exist $(KRN_EXE_PATH)\*.dll del $(KRN_EXE_PATH)\*.dll
	if exist $(KRN_EXE_PATH)\*.sys del $(KRN_EXE_PATH)\*.sys

# Full rebuild
#	
rebuild: clean all

# Relink only
#
relink: cleanlinkout all


