;
; Kernel hook routines
; --------------------
;
; By Enrico Martignetti
;
;
;****************************************************************************

; Include
; =======

; common definitions for 32 bit assembler modules

include AsmDrvCm.inc

;****************************************************************************

; Equate
; ======



;****************************************************************************

; Struct
; ======


;
;****************************************************************************
;

DefCodSeg ;Declare the code segment


DefDatSEg ;Declare the data segment

;-----------------------------------------------------------------------
;
; External symbols

EXTRN	lpKiDeliverApc:dword		;Pointer to KiDeliverApc
EXTRN	KiDeliverApcTrace:proc		;Trace function for KiDeliverApc
EXTRN	lpSwapContext:dword			;Pointer to SwapContext
EXTRN   SwapContextTrace:proc		;Trace function for SwapContext


;****************************************************************************
;
; Static variables

OpeDatSeg


; Statics for SwapContext hook

SWCNHookJmp		byte	0eah
SWCNJmpOff		dword	?
				word	8
				byte	?
				
SWCNptr		dword	?

SWCNOpcSave	dword 2 dup (?)

; Statics for KiDeliverApc hook

KDAPHookJmp		byte	0eah
KDAPJmpOff		dword	?
				word	8
				byte	?
				
KDAPptr		dword	?

KDAPOpcSave	dword 2 dup (?)


CloDatSeg

OpeCodSeg ;Open the code segment

;****************************************************************************
;
; Functions

;-----------------------------------------------------------------------
SetKDAPHook	proc
;
; Sets the hook for nt!KiDeliverApc


		; Set the offset in the jmp instruction
		;
		mov	KDAPJmpOff, offset KDAPHook

		mov eax, lpKiDeliverApc
		
		;mov eax, offset Simul
		
		; Store into KDAPPtr the resume address into
		; the hooked function 
		;
		lea	ebx, [eax + 8]	;The resume instruction after the hook is at + 8
		mov KDAPptr, ebx

		; Save the first 4 bytes of code
		;
		mov ebx,dword ptr [eax]
		mov KDAPOpcSave,ebx
		mov ebx, dword ptr [eax + 4]
		mov KDAPOpcSave + 4, ebx

		; Replace the first 4 bytes with
		; the jmp instruction
		;
		mov ebx, dword ptr KDAPHookJmp
		
		cli
		
		mov [eax], ebx
		mov ebx, dword ptr KDAPHookJmp + 4
		mov [eax + 4], ebx
		
		; Serializing instruction
		;
		cpuid
		
		sti
        ret

SetKDAPHook	endp

;-----------------------------------------------------------------------
SetSWCNHook	proc
;
; Sets the hook for nt!SwapContext


		; Set the offset in the jmp instruction
		;
		mov	SWCNJmpOff, offset SWCNHook

		mov eax, lpSwapContext
		
		;mov eax, offset Simul
		
		; Store into SWCNptr the resume address into
		; the hooked function
		;
		lea	ebx, [eax + 0ah]	;The resume instruction after the hook is at + 0ah
		mov SWCNptr, ebx

		; Save the first 4 bytes of code
		;
		mov ebx,dword ptr [eax]
		mov SWCNOpcSave,ebx
		mov ebx, dword ptr [eax + 4]
		mov SWCNOpcSave + 4, ebx

		; Replace the first 4 bytes with
		; the jmp instruction
		;
		mov ebx, dword ptr SWCNHookJmp
		
		cli
		
		mov [eax], ebx
		mov ebx, dword ptr SWCNHookJmp + 4
		mov [eax + 4], ebx
		
		; Serializing instruction
		;
		cpuid
		
		sti
        ret

SetSWCNHook	endp

;-----------------------------------------------------------------------
KDAPHook	proc

		pushad
		pushfd
		cli
		lea		eax, [esp + 36] ;eax = esp before the pushad, points to
								;the return address
		push	fs:[124h]		;Current thread
		push	[eax]			;push the return address
		push	[eax + 4]		;push PreviousMode
		push	[eax + 8]		;push Reserved
		push	[eax + 0ch]		;push TrapFrame
		call	KiDeliverApcTrace
		add		esp,20
		popfd
		popad

; The instructions skipped in the hooked function are duplicated below

		mov		edi,edi
		push	ebp
		mov		ebp,esp
		and		esp,0FFFFFFF8h
		
		jmp [KDAPptr]

KDAPHook	endp

;-----------------------------------------------------------------------
SWCNHook	proc

		pushad
		pushfd
		cli
		push	esi
		push	edi
		call	SwapContextTrace
		add		esp,8
		popfd
		popad


; The instructions skipped in the hooked function are duplicated below

CallSWCN:
		cmp     byte ptr [esi+6Dh],0
		je		Clear
		pause
		jmp		CallSWCN
Clear:
		jmp [SWCNptr]

SWCNHook	endp


;-----------------------------------------------------------------------
UnhookKDAP	proc

	mov	eax, lpKiDeliverApc
	;mov	eax, offset Simul
	
	mov ebx, KDAPOpcSave
	
	cli
	
	mov [eax], ebx
	mov ebx, KDAPOpcSave + 4
	mov [eax + 4], ebx
	
	cpuid
	
	sti
	
	ret

UnhookKDAP	endp


;-----------------------------------------------------------------------
UnhookSWCN	proc

	mov	eax, lpSwapContext
	;mov	eax, offset Simul
	
	mov ebx, SWCNOpcSave
	
	cli
	
	mov [eax], ebx
	mov ebx, SWCNOpcSave + 4
	mov [eax + 4], ebx
	
	cpuid
	
	sti
	
	ret

UnhookSWCN	endp


CloCodSeg ;Close the code segment


end


